image: docker:latest

services:
  - docker:dind

variables:
  HEROKU_API_KEY: $HEROKU_API_KEY
  DOCKER_REGISTRY_USER: $DOCKER_REGISTRY_USER
  DOCKER_REGISTRY_PASSWORD: $DOCKER_REGISTRY_PASSWORD
  DOCKER_REGISTRY: $DOCKER_REGISTRY
  IMAGE_TAG: $DOCKER_REGISTRY_USER/$IMAGE_NAME:v0.1

stages:
  - Runtests
  - DockerBuildStage
  - DeployToHerokuStage

runtests:
  stage: Runtests
  script:
    - docker build --target test --tag my-test-image .
    - docker run --env-file .env.test my-test-image

builddockerimage:
  stage: DockerBuildStage
  script:
    - docker build --target production . --tag $IMAGE_TAG
    - docker login -u "$DOCKER_REGISTRY_USER" -p "$DOCKER_REGISTRY_PASSWORD" $DOCKER_REGISTRY
    - docker push $IMAGE_TAG

deploytoheroku:
  stage: DeployToHerokuStage
  script:
    - docker login -u "$DOCKER_REGISTRY_USER" -p "$DOCKER_REGISTRY_PASSWORD" $DOCKER_REGISTRY
    - apk add --update-cache curl bash npm
    - curl https://cli-assets.heroku.com/install.sh | sh
    - heroku authorizations:create
    - heroku container:login
    - docker pull $IMAGE_TAG
    - docker tag $IMAGE_TAG registry.heroku.com/aptodoapp/web
    - docker push registry.heroku.com/aptodoapp/web
    - heroku container:release web --app aptodoapp
  only:
    variables:
      - ($CI_COMMIT_BRANCH == "main")
